diff a/src/hotspot/share/gc/z/c1/zBarrierSetC1.hpp b/src/hotspot/share/gc/z/c1/zBarrierSetC1.hpp
--- a/src/hotspot/share/gc/z/c1/zBarrierSetC1.hpp
+++ b/src/hotspot/share/gc/z/c1/zBarrierSetC1.hpp
@@ -85,11 +85,14 @@
 #ifndef PRODUCT
   virtual void print_name(outputStream* out) const;
 #endif // PRODUCT
 };
 
+class SCAddressTable;
+
 class ZBarrierSetC1 : public BarrierSetC1 {
+  friend SCAddressTable;
 private:
   address _load_barrier_on_oop_field_preloaded_runtime_stub;
   address _load_barrier_on_weak_oop_field_preloaded_runtime_stub;
   address _store_barrier_on_oop_field_with_healing;
   address _store_barrier_on_oop_field_without_healing;
